//+------------------------------------------------------------------+
//| MasterEA.mq4.mq4
//| Copyright  2007, Pradip - Programmed By "Sleepless"Damian Burrowes
//| www.sleeplessdamian.com
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, oilfxpro@raj-enterprises.co.uk - Programmed By 'Sleepless'Damian Burrowes"
#property link      "www.sleeplessdamian.com"

extern string    normal="==== Normal Entries ====";
extern int       TP                      = 55;              // If not 0, profit target for all normal orders
extern int       SL                      = 40;             // Stoploss for first orders
extern int       RangeDeviation          = 1;              // Allowable pips +/- offset for entries
extern bool      Disable_Longs           = false;          // Long order creating section of the EA will not run
extern bool      Disable_Shorts          = false;          // Short order creating section of the EA will not run

extern string    settings="==== Standard Settings ====";
extern double    Lots                    = 0.1;            // Lots used for orders
extern string    order="==== Order Settings ====";
extern int       Max_Longs               = 1;
extern int       Max_Shorts              = 1;
extern int       Max_Total               = 2;              // Maximum number of orders allowed per pair (and per time-frame if TimeSpecific is true)
//extern string    times="==== Trade Times ====";
//extern int    StartTrading            = 8;
//extern int    StopTrading             = 20;
//extern string    closing="==== Close Times ====";
//extern int    ClosingDay              = 0;          // Day of week to activate; used for CloseOnTime;

                                                           //    Input should be uppercase or lowercase ("FRIDAY", "friday", "ANY", "any")

                                                           //    Three letter abbreviation may also be used ("FRI", "fri", "ANY", "any")

//extern int    ClosingTime              = 19;
extern string    autolot="==== Automatic Lots ====";
extern bool      AutoLotSize             = false;          // If true, lots are calculated based on equity
extern double    RiskPercentage          = 2;              // Percentage of equity to be used for each position
extern double    MaxAllowedLotSize       = 1;              // User specified maximum Lot Size for orders
extern string    manage="==== Stop Management ====";
extern int       BreakEven               = 0;              // Set Stoploss to breakeven (order's open price) at X pips profit
extern int       TrailingStop            = 0;              // Stoploss follows behind current price by X pips
extern int       StartTrailingStop        =0;
extern bool      OnlyTrailProfits        = false;          // Trailing Stop will only trail when order is profitable
extern bool      Disable_Comments        = false;          // EA will not display comments on screen
extern int       LoopTry                 = 2;              // Number of attempts used by order sending functions
extern int       Slippage                = 2;
extern string    closeafter=" New Functions";
extern int TradeHours =24;
extern int MaxAllowedTrades=2;
extern int DailyAccountLossAllowed=2;
extern int DeletePendingAfter =0;
extern int CloseOrdersOnFridayAt=19;
extern int WeekendDissable=16;
extern int WeekendEnable=10;
extern int NewsDissable=7;
extern int NewsEnable=8;
 
 
      
int FirstTrade=0;
int MLastTrade=0;
int TotalTrades=0;
int TimeStartDay;
double AllowedAccountLoss;
double DailyAccount;
int TimeStartThreeday;
double ThreeDayAccountLossAllowed;
double ThreeDailyAccount;
int TimeStartThreeDay;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
GlobalVariableSet( "TP",TP);      
GlobalVariableSet( "SL",SL);         
GlobalVariableSet( "RangeDeviation",RangeDeviation);     
GlobalVariableSet( "Disable_Longs",Disable_Longs);    
GlobalVariableSet( "Disable_Shorts",Disable_Shorts);  
GlobalVariableSet( "Lots",Lots);  
GlobalVariableSet( "Max_Longs",Max_Longs);            
GlobalVariableSet( "Max_Shorts",Max_Shorts);          
GlobalVariableSet( "Max_Total",Max_Total);            
//GlobalVariableSet( "StartTrading",StartTrading);      
//GlobalVariableSet( "StopTrading",StopTrading);        
//GlobalVariableSet( "ClosingDay",ClosingDay);          
//GlobalVariableSet( "ClosingTime",ClosingTime);        
GlobalVariableSet( "AutoLotSize",AutoLotSize);        
GlobalVariableSet( "RiskPercentage",RiskPercentage);  
GlobalVariableSet( "MaxAllowedLotSize",MaxAllowedLotSize);
GlobalVariableSet( "BreakEven",BreakEven);           
GlobalVariableSet( "TrailingStop",TrailingStop);     
GlobalVariableSet( "OnlyTrailProfits",OnlyTrailProfits);
GlobalVariableSet( "Disable_Comments",Disable_Comments);
GlobalVariableSet( "LoopTry",LoopTry);  
GlobalVariableSet( "Slippage", Slippage);    

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//a) If account balance drops by 5 % within 24 hours disable all new
//orders and close all existing orders (the 5% is a variable in properties)
if(DailyAccountLossAllowed !=0 && TimeStartDay==0) 
{
AllowedAccountLoss=AccountBalance()/100*DailyAccountLossAllowed;DailyAccount=AccountBalance();TimeStartDay=TimeCurrent();
}
if(DailyAccountLossAllowed !=0) 
{
if(AccountBalance()<DailyAccount-AllowedAccountLoss)CloseAll();GlobalVariableSet("TradingAllowed",false);
if(TimeCurrent()-TimeStartDay>86400)AllowedAccountLoss=AccountBalance()/100*DailyAccountLossAllowed;DailyAccount=AccountBalance();TimeStartDay=TimeCurrent();
}

//If EA incurs losses of more than 3% of account
//size in a 72 hour period ,disable E A
if(TimeStartThreeday==0)ThreeDayAccountLossAllowed=AccountBalance()/100*3;ThreeDailyAccount=AccountBalance();TimeStartThreeday=TimeCurrent();
if(TimeCurrent()-TimeStartThreeDay>259200)ThreeDayAccountLossAllowed=AccountBalance()/100*3;ThreeDailyAccount=AccountBalance();TimeStartThreeDay=TimeCurrent();
if(AccountBalance()<ThreeDailyAccount-ThreeDayAccountLossAllowed)CloseAll();GlobalVariableSet("TradingAllowed",false);

//c)If EA places more than x orders in 24 hours disable EA. If EA places
//more than x orders in 48 hours disable EA
if(GlobalVariableGet("LastTrade")>MLastTrade&&MLastTrade==0)FirstTrade=GlobalVariableGet("LastTrade");
if(GlobalVariableGet("LastTrade")>MLastTrade)MLastTrade=GlobalVariableGet("LastTrade"); TotalTrades=TotalTrades+1;
if(MLastTrade-FirstTrade>3600*TradeHours && TotalTrades>MaxAllowedTrades)GlobalVariableSet("TradingAllowed",false);

//C) Close all open orders at market on Friday at x hours
if(TimeDayOfWeek(TimeCurrent())==5 && TimeHour(TimeCurrent())==CloseOrdersOnFridayAt)CloseAll(); 

//e)disable all new orders between x hours on Friday and x hours Monday
if(WeekendDissable!=0)if(TimeDayOfWeek(TimeCurrent())==5 && TimeHour(TimeCurrent())==WeekendDissable)GlobalVariableSet("TradingAllowed",false);
if(WeekendEnable!=0)if(TimeDayOfWeek(TimeCurrent())==1 && TimeHour(TimeCurrent())==WeekendEnable)GlobalVariableSet("TradingAllowed",true);


//f)disable all new orders during newstime ie x hours to x hours
if(NewsDissable!=0)if(TimeHour(TimeCurrent())==NewsDissable)GlobalVariableSet("TradingAllowed",false);
if(NewsEnable!=0)if(TimeHour(TimeCurrent())==NewsEnable)GlobalVariableSet("TradingAllowed",true);

trailstops();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//Close all orders---------------------------------------------------+
//+------------------------------------------------------------------+
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
        switch(type)
    {
      //Close open orders
      case OP_BUY  :
      case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),Ask,50);
    }

    
  }
}
//+------------------------------------------------------------------+
void trailstops()
{

   for(int pos=0;pos<OrdersTotal();pos++)
   {   
   if(OrderSelect(pos,SELECT_BY_POS)==false) continue;

      if(OrderType() == OP_BUY)
      {
          if(TrailingStop >0 && MarketInfo(Symbol(), MODE_BID) - OrderOpenPrice()>(StartTrailingStop*Point) && OrderStopLoss( )  < MarketInfo(Symbol(), MODE_BID) - TrailingStop*Point && MarketInfo(Symbol(), MODE_BID) - OrderOpenPrice()>(TrailingStop*Point)) 
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Blue);  
          }
          
         if(Bid >= OrderOpenPrice() + BreakEven * Point && BreakEven !=0)
         {
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);  
         }
    
      }
   //d) Delete all pending orders after x hours from being placed
         
      if(OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP || OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP)
      {
         if(DeletePendingAfter!=0 && TimeCurrent() > OrderOpenTime()+DeletePendingAfter*3600)
         {
         OrderDelete( OrderTicket() );
         }
      }

      if(OrderType() == OP_SELL)
      {
          if(TrailingStop >0 &&  OrderOpenPrice()-MarketInfo(Symbol(), MODE_ASK) > StartTrailingStop*Point && OrderStopLoss( )  > MarketInfo(Symbol(), MODE_ASK) + TrailingStop*Point&&  OrderOpenPrice()-MarketInfo(Symbol(), MODE_ASK) > TrailingStop*Point) 
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Blue);  
          }
    
    
          if(Ask <= OrderOpenPrice() - BreakEven * Point && BreakEven !=0)
          {
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);  
          }
           
      }

   }
}

//+------------------------------------------------------------------+

